.\"	$NetBSD: ccd.4,v 1.28 2005/06/20 13:25:24 peter Exp $
.\"
.\" Copyright (c) 1996, 1997 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Jason R. Thorpe.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.\" Copyright (c) 1994 Jason Downs.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR(S) ``AS IS'' AND ANY EXPRESS
.\" OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
.\" WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
.\" DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR(S) BE LIABLE FOR ANY DIRECT,
.\" INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
.\" (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
.\" SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
.\" CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd March 5, 2004
.Dt CCD 4
.Os
.Sh NAME
.Nm ccd
.Nd Concatenated disk driver
.Sh SYNOPSIS
.Cd "pseudo-device ccd" Op Ar count
.Sh DESCRIPTION
The
.Nm
driver provides the capability of combining one or more disks/partitions
into one virtual disk.
.Pp
This document assumes that you're familiar with how to generate kernels,
how to properly configure disks and pseudo-devices in a kernel
configuration file, and how to partition disks.
.Pp
Note that the
.Sq raw
partitions of the disks
.Pa must not
be combined.
Each component partition should be offset at least one cylinder
from the beginning of the component disk.
This avoids potential conflicts between the component disk's
disklabel and the
.Nm Ns 's
disklabel.
The kernel will only allow component partitions of type
.Dv FS_CCD .
But for now, it allows partition of all types since some port
lacks support of an on-disk BSD disklabel.
The partition of
.Dv FS_UNUSED
may be rejected because device driver of component disk will refuse it.
.Pp
In order to compile in support for the
.Nm ,
you must add a line similar
to the following to your kernel configuration file:
.Bd -unfilled -offset indent
pseudo-device	ccd	4	# concatenated disk devices
.Ed
.Pp
The count argument is how many
.Nm Ns s
memory is allocated for at boot time.
In this example, no more than 4
.Nm Ns s
may be configured.
.Pp
A
.Nm
may be either serially concatenated or interleaved.
To serially concatenate the partitions, specify the interleave factor of 0.
.Pp
If a
.Nm
is interleaved correctly, a
.Dq striping
effect is achieved, which can increase performance.
.\" The optimum interleave factor is typically the size of a track,
.\" see
.\" .Dq sectors/track
.\" value in
.\" .Xr disklabel 8
.\" output.
Since the interleave factor is expressed in units of
.Dv DEV_BSIZE ,
one must account for sector sizes other than
.Dv DEV_BSIZE
in order to calculate the correct interleave.
The kernel will not allow an interleave factor less than the size
of the largest component sector divided by
.Dv DEV_BSIZE .
.Pp
Note that best performance is achieved if all component disks have the same
geometry and size.
Optimum striping cannot occur with different disk types.
.Pp
Also note that the total size of concatenated disk may vary depending on
the interleave factor even if the exact same components are concatenated.
And an old on-disk disklabel may be read after interleave factor change.
As a result, the disklabel may contain wrong partition geometry and
will cause an error when doing I/O near the end of concatenated disk.
.Pp
There is a run-time utility that is used for configuring
.Nm Ns s .
See
.Xr ccdconfig 8
for more information.
.Sh WARNINGS
If just one (or more) of the disks in a non-mirrored
.Nm
fails, the entire file system will be lost.
.Sh FILES
.Bl -tag -width /dev/XXrXccdX -compact
.It Pa /dev/{,r}ccd*
.Nm
device special files.
.El
.Sh SEE ALSO
.Xr config 1 ,
.Xr MAKEDEV 8 ,
.Xr ccdconfig 8 ,
.Xr fsck 8 ,
.Xr mount 8 ,
.Xr newfs 8
.Sh HISTORY
The concatenated disk driver was originally written at the University of Utah.
